﻿#pragma warning disable CA1416
using System.Management;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        try
        {
            ManagementObjectSearcher searcher;

            // PC 모델 및 제조업체 정보
            searcher = new ManagementObjectSearcher("SELECT * FROM Win32_ComputerSystem");

            foreach(ManagementObject mo in searcher.Get())
            {
                Console.WriteLine($"PC 모델               : {mo["Model"       ]}");
                Console.WriteLine($"제조업체              : {mo["Manufacturer"]}");
            }

            // 제조번호(시리얼 넘버) 정보
            searcher = new ManagementObjectSearcher("SELECT * FROM Win32_BIOS");

            foreach(ManagementObject mo in searcher.Get())
            {
                Console.WriteLine($"제조번호(시리얼 넘버) : {mo["SerialNumber"]}");
            }

            // CPU 정보
            searcher = new ManagementObjectSearcher("SELECT * FROM Win32_Processor");

            foreach(ManagementObject mo in searcher.Get())
            {
                Console.WriteLine($"CPU                   : {mo["Name"]}");
            }

            // 메인보드 정보
            searcher = new ManagementObjectSearcher("SELECT * FROM Win32_BaseBoard");

            foreach(ManagementObject mo in searcher.Get())
            {
                Console.WriteLine($"메인보드 제조사       : {mo["Manufacturer"]}");
                Console.WriteLine($"메인보드 제품 ID      : {mo["Product"     ]}");
                Console.WriteLine($"메인보드 시리얼 번호  : {mo["SerialNumber"]}");
            }

            // 메모리 용량 정보
            searcher = new ManagementObjectSearcher("SELECT * FROM Win32_ComputerSystem");

            foreach(ManagementObject mo in searcher.Get())
            {
                ulong totalPhysicalMemory = Convert.ToUInt64(mo["TotalPhysicalMemory"]);

                Console.WriteLine($"메모리 용량           : {(totalPhysicalMemory / (1024 * 1024 * 1024))} GB");
            }
        }
        catch (Exception exception)
        {
            Console.WriteLine("오류 발생 : " + exception.Message);
        }

        Console.WriteLine("아무 키나 누르면 종료됩니다...");

        Console.ReadKey(false);
    }

    #endregion
}